#!/usr/local/bin/python3
import re, codecs
from collections import OrderedDict

print("#### 030_make_outTable.py ####")

def make_sbjct_stock(line_sbjct):
    #print("line_sbjct", line_sbjct)
    match = re.search("Sbjct +(\d+) +[^ ]+ +(\d+)$", line_sbjct)
    former = match.group(1)
    latter = match.group(2)
    return former, latter


def get_each_database(lines_fn):
    dic_each_database_fn = OrderedDict()
    flag = 0
    database = ""
    lines_stock = []
    nameline = ""
    flag_nameline = 0
    for line in lines_fn:
        line = line.rstrip("\n")
        if line.startswith("Database:"):
            if flag == 1:
                 dic_each_database_fn[database] = lines_stock
                 database = line
                 lines_stock = []
            if flag == 0:
                database = line
                flag = 1
        else:
            if line.startswith("Query=") or line.startswith(" Score") or line.startswith(" Identities") or line.startswith(" Strand") or line.startswith("Sbjct") or line.startswith("***** No hits found *****"):
                lines_stock.append(line)

            if flag_nameline == 1:
                if line.startswith("Length"):
                    lines_stock.append(nameline)
                    nameline = ""
                    lines_stock.append(line)
                    flag_nameline = 0
                else:
                    nameline += line
            else:
                if line.startswith(">"):
                    nameline = line
                    flag_nameline = 1
                
    dic_each_database_fn[database] = lines_stock

    list_each_query_fn = []
    for database, recs in dic_each_database_fn.items():
        list_each_query_fn.append([database, recs])

    return list_each_query_fn


def clean_each_blasthit(list_each_query_fn):
    list_each_blasthit_fn = []
    query = ""
    nameline = ""
    for ele in list_each_query_fn:
        database = ele[0]
        lines = ele[1]
        for line in lines:
            if not line:
                continue
            if line.startswith("Query"):
                query = line
                nameline = ""
            elif line == "***** No hits found *****":
                list_each_blasthit_fn.append([database, query, ">" + line, ">" + line])
            elif line.startswith(">"):
                nameline = line
                #nameline = re.sub(" .*$", "", nameline)
                list_each_blasthit_fn.append([database, query, nameline, nameline])
            else:
                list_each_blasthit_fn.append([database, query, nameline, line])
    return list_each_blasthit_fn


def clean_each_blasthit2(list_each_query_fn):
    list_each_query2_fn = []
    flag = 0
    database_stock = ""
    query_stock = ""
    nameline_stock = ""
    length_stock = ""
    score_stock = ""
    identity_stock = ""
    strand_stock = ""
    sbjct_stock = []
    for line in list_each_query_fn:
        database = line[0]
        query = line[1]
        content = line[3]
        #print(line)
        #continue
        #'''
        if content.startswith(">"):
            #print(content)
            if flag == 0:
                #print("flag == 0", content)
                #print("content", content)
                #exit()
                nameline_stock = content
                database_stock = database
                query_stock = query
                flag = 1
            else:
                #print("flag == 1", content)
                #print("database_stock", database_stock)
                #print("query_stock", query_stock)
                #print("nameline_stock", nameline_stock)
                #print("length_stock", length_stock)
                #print("score_stock", score_stock)
                #print("identity_stock", identity_stock)
                #print("strand_stock", strand_stock)
                #print("sbjct_stock", sbjct_stock)
                #print()
                list_each_query2_fn.append([database_stock, query_stock, nameline_stock, length_stock,score_stock, identity_stock, strand_stock, sbjct_stock])
                database_stock = database
                query_stock = query
                nameline_stock = content
                length_stock = ""
                score_stock = ""
                identity_stock = ""
                strand_stock = ""
                sbjct_stock = []
        elif content.startswith("Length="):
            length_stock = content
        elif content.startswith(" Score ="):
            score_stock = content
        elif content.startswith(" Identities ="):
            identity_stock = content
        elif content.startswith(" Strand="):
            strand_stock = content
        elif content.startswith("Sbjct  "):
            sbjct_1, sbjct_2 = make_sbjct_stock(content)
            #print(sbjct_1, sbcjt_2)
            #exit()
            sbjct_stock.append(sbjct_1)
            sbjct_stock.append(sbjct_2)
        #'''
    #print("database_stock", database_stock)
    #print("query_stock", query_stock)
    #print("nameline_stock", nameline_stock)
    #print("length_stock", length_stock)
    #print("score_stock", score_stock)
    #print("identity_stock", identity_stock)
    #print("strand_stock", strand_stock)
    #print("sbjct_stock", sbjct_stock)
    list_each_query2_fn.append([database_stock, query_stock, nameline_stock, length_stock, score_stock, identity_stock, strand_stock, sbjct_stock])
    
    return list_each_query2_fn


def read_blastnRes2(infileFN):
    f = open(infileFN)
    lines = list(f)
    f.close()

    list_each_database = get_each_database(lines)
    list_each_blasthit_raw = clean_each_blasthit(list_each_database)
    #print("list_each_blasthit_raw", list_each_blasthit_raw)
    #exit()
    list_each_blasthit = clean_each_blasthit2(list_each_blasthit_raw)
    '''
    for recs in list_each_blasthit:
        database_stock = recs[0]
        query_stock = recs[1]
        nameline_stock = recs[2]
        length_stock = recs[3]
        score_stock = recs[4]
        identity_stock = recs[5]
        strand_stock = recs[6]
        sbjct_stock = recs[7]
        print("database_stock", database_stock)
        print("query_stock", query_stock)
        print("nameline_stock", nameline_stock)
        print("length_stock", length_stock)
        print("score_stock", score_stock)
        print("identity_stock", identity_stock)
        print("strand_stock", strand_stock)
        print("sbjct_stock", sbjct_stock)
        if sbjct_stock:
            print(min(sbjct_stock), max(sbjct_stock))
        print()
    '''
    return list_each_blasthit


def add_recs_blastout_sequenceID(filename_blastout):
    #print("### add_recs_blastout_sequenceID ####<br>")
    #print("filename_blastout", filename_blastout, "<br>")

    recs_blastnRes = read_blastnRes2(filename_blastout)
    recs_blastout_sequenceID = []
    for rec in  recs_blastnRes:
        #for ele in rec:
        #    print("ele", ele, "<br>")
        #exit()
        database = rec[0]
        query = rec[1]
        blastHit = rec[2]
        length = rec[3]
        score = rec[4]
        identity = rec[5]
        strand = rec[6]
        position = rec[7]
        #print("database", database, "<br>")
        #print("query", query, "<br>")
        #print("blastHit", blastHit, "<br>")
        #print("length", length, "<br>")
        #print("score", score, "<br>")
        #print("identity", identity, "<br>")
        #print("strand", strand, "<br>")
        #print("position", position, "<br>")

        #print("blastHit", blastHit, "<br>")
        #exit()

        sequenceID = ""
        if blastHit.startswith(">SAMP") or blastHit.startswith(">USERDB") :
            match = re.search("^>([^_]+)_", blastHit)
            sequenceID = match.group(1)
            #print("sequenceID", sequenceID, "<br><br>")
        else:
            match = re.search("^>([^\.]+\.\d+)\.", blastHit)
            sequenceID = match.group(1)
            #print("sequenceID", sequenceID, "<br><br>")
            #exit()
        recs_blastout_sequenceID.append([database, query, blastHit, length, score, identity, strand, position, sequenceID])
    return recs_blastout_sequenceID

def recs_2d_to_ordDict_old(recs_blastout_tmp):
    flag1 = 1
    query_content = []
    dic_blastResult_fn = OrderedDict()
    query1 = ""
    for rec in recs_blastout_tmp:
        query = rec[1]
        rec1 = rec
        #print("query", query)
        if flag1 == 1:
            #print("flag1")
            query_content.append(rec1)
        elif query == query1:
            query_content.append(rec1)
        else:
            #print("query_content", query_content)
            dic_blastResult_fn[query1] = query_content
            #print("dic_blastResult_fn", dic_blastResult_fn)
            #exit()
            query_content = []
            query_content.append(rec1)
        flag1 += 1
        query1 = query
    dic_blastResult_fn[query1] = query_content
    #print("dic_blastResult_fn", dic_blastResult_fn)
    #exit()
    return(dic_blastResult_fn)

def recs_2d_to_ordDict(recs_blastout_tmp):
    flag1 = 1
    query_content = []
    dic_blastResult_fn = OrderedDict()
    query1 = ""
    for rec in recs_blastout_tmp:
        query = rec[1]
        rec1 = rec
        #print("query", query)
        if not query in dic_blastResult_fn.keys():
            dic_blastResult_fn[query] = [rec1]
        else:
            dic_blastResult_fn[query].append(rec1)
    return(dic_blastResult_fn)

def screenout_dic(dic_blastResult_fn):
    for query, recs in dic_blastResult_fn.items():
        count_b = 1

        print("####################")
        print("query:", query)
        for eles in recs:
            if count_b > num_report_per_query:
                break
            blastHit = eles[2]
            assignedTaxon = re.sub("^.*;species_", "species_", blastHit)
            identity = eles[5]
            print("count_b:", count_b)
            print("assignedTaxon:", assignedTaxon)
            print("identity:", identity)
            print("")
            count_b += 1

def print_csv_dic(dic_blastResult_fn, outfile):
    count_row = 1
    out = codecs.open(outfile, "w", 'shift_jis')
    out.write("cout_row, ASV_ID,Target_top_family1,Target_top_species1,和名1,Identity_top1\n")
    for query, recs in dic_blastResult_fn.items():
        count_num_report_perl_query = 1
        line = ""
        #print("query:", query)
        query = re.sub("Query= ", "", query)
        line += str(count_row) + "," +query
        for eles in recs:
            #print("count_num_report_perl_query", count_num_report_perl_query)
            if count_num_report_perl_query > num_report_per_query:
                #print("break")
                break

            blastHit = eles[2]
            assignedTaxon = re.sub("^.*;species_", "species_", blastHit)

            #print("blastHit:", blastHit)
            match1 = re.search(";family_([^_]+)_", blastHit)
            if match1:
                family = match1.group(1)
                #print("family: " + family)
                line += "," + family
            else:
                #print("blastHit:", blastHit)
                #print("cannot find match1")
                line += ", noFamily"

            match2 = re.search(";species_([^_]+)_", blastHit)
            species = ""
            if match2:
                species = match2.group(1)
                species = re.sub(" ", "-", species)
                line += "," + species
            else:
                line += ", noSpecies"

            scinetificName_Jname = add_scinetificName_Jname(species)
            line += "," + scinetificName_Jname

            identity = eles[5]
            #print("identity:", identity)
            match3 = re.search("Identities = (\d+)\/(\d+) ", identity)
            if match3:
                numerator = match3.group(1)
                denominator = match3.group(2)
                identity = round(float(int(numerator)/int(denominator)),5) * 100
                line += "," + str(identity)
            else:
                line += ", noIdentities"
                
            #print("line", line)
            
            count_num_report_perl_query += 1

        count_row += 1
        out.write(line + "\n")
        #print("")

def make_dictionary_English2Japanese():
    dictionary_English2Japanese = {}

    fTMP = open(dbAddress_English2Japanese, encoding='CP932')
    lines_English2Japanese = list(fTMP)
    fTMP.close()
    
    for line in lines_English2Japanese:
        Ename, Jname = line.split("\t")
        dictionary_English2Japanese[Ename] = Jname
    
    return dictionary_English2Japanese

def add_scinetificName_Jname(name_species):
    print("name_species", name_species)
    Ename_tmp = re.sub("^[A-Z][A-Z]\d+-", "", name_species)
    #print("Ename_tmp1", Ename_tmp, "<br>")
    Ename_tmp = re.sub("^[A-Z]\d+-", "", Ename_tmp)
    #print("Ename_tmp2", Ename_tmp, "<br>")
    Jname = dictionary_English2Japanese.get(Ename_tmp, "不明")
    Jname = Jname.rstrip("\n")
    #print("Jname", Jname)
    return Jname

#030_Sname_Jname.txt

############################################# 
num_report_per_query = 2
recs_blastout_tmp = add_recs_blastout_sequenceID("020_out_blast.txt")    

dbAddress_English2Japanese = "030_Sname_Jname.txt"
dictionary_English2Japanese = make_dictionary_English2Japanese()

#dic_blastResult_old = recs_2d_to_ordDict_old(recs_blastout_tmp)
#print("dic_blastResult_old")
#for name, recs in dic_blastResult_old.items():
#    print(name)
#    for rec in recs:
#        print(rec)
#print("dic_blastResult")
dic_blastResult = recs_2d_to_ordDict(recs_blastout_tmp)
#for name, recs in dic_blastResult.items():
#    print(name)
#    for rec in recs:
#        print(rec)

#screenout_dic(dic_blastResult)
#exit()

outfile = "030_otuTable.csv"
print_csv_dic(dic_blastResult, outfile)


               